/*
* This class is used for development of the CompanionScreen
* it provides a bunch of tools to simulates de C# side messaging
*/
var GameSimulatorToolkit = function(sendMessageToCompanionCallback)
{
    var self = this;
    var containerDiv = null;

    var init = function()
    {
        containerDiv = document.getElementById("gameSimulatorToolkit");
        containerDiv.style.display = "block";
        var b = document.createElement("BUTTON");
        b.textContent = "test";
        /*b.addEventListener("click", function(){
            sendMessageToCompanion(JSON.stringify({"category": "system-check", "action": "ping", "parameters": ["to JS"]}));
        });*/
        b.addEventListener("click", function(){
            sendMessageToCompanion(JSON.stringify({"category": "game", "action": "game-panel-html", "parameters": [testPluginSourceCode]}));
        });
        



        containerDiv.appendChild(b);
    }

    var sendMessageToCompanion = function(jsonData)
    {
        if(sendMessageToCompanionCallback != null)
            sendMessageToCompanionCallback(jsonData);
    }

    this.companionOutgoingMessage = function(jsonData)
    {
        /* the companion send a message destinated to c#, we must simulate the c# code here */
        //The form of the message is '{"category": category, "action": action, "parameters": parameters}'
        console.log(jsonData);
        var msg = JSON.parse(jsonData);
        if(msg["category"] == "system-check" && msg["action"] == "ping" && msg["parameters"] == "to C#") // {"category":"","action":"ping","parameters":"to C#"} 
            sendMessageToCompanion(JSON.stringify({"category": "system-check", "action": "pong", "parameters": ["from C#"]}));
    }

    init.call(self);
}


var testPluginSourceCode = "This is a dynamically loaded html panel<br/> \
it can contains html links ! \
<a href=\"#\" onclick=\"console.log('link from CompanionScreen.GamePanel clicked'); return false;\">Test Link</a> \
<script type=\"text/javascript\" language=\"Javascript\"> \
console.log('----------- execute script tag'); \
var GamePanelPlugin = function(containerDiv){ \
  var self = this; \
\
var init = function() \
  { \
    console.log('++++++++ GamePanelPlugin is initialized'); \
    containerDiv.innerHTML += '<br/> ADDED BY GamePanelPlugin'; \
  } \
\
  self.processMessage = function(msg) \
  { \
    console.log('++++++++ GamePanelPlugin got a message : '+JSON.stringify(msg)); \
  } \
\
  init.call(self); \
}; \
</script>";