var ScreenCompanionGame = function(sendMessageAction)
{
    var self = this;
    var containerDiv = null;
    var plugin = null;

    var init = function()
    {
        containerDiv = document.getElementById("scGameContainer");
        containerDiv.innerHTML += " dynamic";    
    }

    this.setConnectedUsers = function(usersInfo)
    {
        for(var i=0; i<usersInfo.length; i++)
        {
            let userId = usersInfo[i][0];
            let usernickName = usersInfo[i][1];
            console.log("user in room: "+userId+" - " + usernickName);
        }
    }

    this.addConnectedUser = function(userInfo)
    {
        let userId = userInfo[0];
        let usernickName = userInfo[1];
        console.log("user enters room: "+userId+" - " + usernickName);
    }

    this.setUserVideoIsReady = function(userId)
    {
        console.log("user video ready: "+userId);
    }

    this.setHTMLContent = function(contentHtml)
    {
        GamePanelPlugin = null; // this can be declared in the contentHtml
        plugin = null;
        //console.log("SET HTML CONTENT TO " + contentHtml);
        containerDiv.innerHTML = contentHtml;
        var scriptSources = containerDiv.getElementsByTagName("SCRIPT");
        if(scriptSources.length > 0)
        {
            //try { console.log("<><>text<><>"+scriptSources[0].text); }catch(e1){}
            //try { console.log("<><>nodeValue<><>"+scriptSources[0].nodeValue); }catch(e1){}
            //try { console.log("<><>innerHTML<><>"+scriptSources[0].innerHTML); }catch(e1){}
            //try { console.log("<><>textcontent<><>"+scriptSources[0].textContent); }catch(e1){}
            eval(scriptSources[0].text);
        }
        if(typeof(GamePanelPlugin) == "function")
        {
            plugin = new GamePanelPlugin(containerDiv, sendMessageAction);
            plugin.processMessage({"category": "game-panel-plugin", "action": "ready", "parameters": ["dummyParameter0", "dummyParameter0"]})
        }
    }

    this.forwardMessageToPlugin = function(msg)
    {
        if(msg["category"] == "game-panel-plugin" && plugin != null)
        {
            plugin.processMessage(msg);
        }
    }

    init.call(self);
}