var ScreenCompanionAccount = function(sendMessageAction)
{
    var self = this;
    var containerDiv = null;
    var usernameSpan = null;
    var leaderBoardPositionSpan = null;
    var dronesDestructionStatsTodaySpan = null;
    var dronesDestructionStatsYesterdaySpan = null;
    var dronesDestructionStatsThisMonthSpan = null;
    var dronesDestructionStatsLastMonthSpan = null;
    var dronesDestructionStatsTotalSpan = null;

    var init = function()
    {
        containerDiv = document.getElementById("scAccountContainer");
        
        usernameSpan = containerDiv.querySelector("#scPanelAccountUsername");
        usernameSpan.textContent = "-";
        leaderBoardPositionSpan = containerDiv.querySelector("#scPanelAccountLeaderboardPosition");
        leaderBoardPositionSpan.textContent = "-"; // ⇧ ⇩
        dronesDestructionStatsTodaySpan = containerDiv.querySelector("#scPanelAccountDronesStatsToday");
        dronesDestructionStatsTodaySpan.textContent = "-";
        dronesDestructionStatsYesterdaySpan = containerDiv.querySelector("#scPanelAccountDronesStatsYesterday");
        dronesDestructionStatsYesterdaySpan.textContent = "-";
        dronesDestructionStatsThisMonthSpan = containerDiv.querySelector("#scPanelAccountDronesStatsThisMonth");
        dronesDestructionStatsThisMonthSpan.textContent = "-";
        dronesDestructionStatsLastMonthSpan = containerDiv.querySelector("#scPanelAccountDronesStatsLastMonth");
        dronesDestructionStatsLastMonthSpan.textContent = "-";
        dronesDestructionStatsTotalSpan = containerDiv.querySelector("#scPanelAccountDronesStatsTotal");
        dronesDestructionStatsTotalSpan.textContent = "-";
            
    }

    this.setDataAll = function(dataset)
    {
        usernameSpan.textContent = dataset[0].toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
        leaderBoardPositionSpan.textContent = dataset[1].toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ") + "("+ (parseInt(dataset[2])<0 ? "⇩ "+dataset[2] : "⇧ "+dataset[2]) +")";
        dronesDestructionStatsTodaySpan.textContent = dataset[3].toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
        dronesDestructionStatsYesterdaySpan.textContent = dataset[4].toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
        dronesDestructionStatsThisMonthSpan.textContent = dataset[5].toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
        dronesDestructionStatsLastMonthSpan.textContent = dataset[6].toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
        dronesDestructionStatsTotalSpan.textContent = dataset[7].toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
    }

    this.setDailyCapsulesCount = function(val)
    {
        dronesDestructionStatsTodaySpan.textContent = val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
    }

    init.call(self);
}