var ScreenCompanionDeveloperTools = function(sendMessageAction)
{
    var self = this;
    var containerDiv = null;
    var pingCSharpButtonDiv = null;

    var init = function()
    {
        containerDiv = document.getElementById("scDevToolsContainer");
        pingCSharpButtonDiv = document.getElementById("scDevToolsPingCSharpButton");
        pingCSharpButtonDiv.addEventListener("click", function(){ 
            if(sendMessageAction != null){ sendMessageAction("system-check", "ping", "to C#");}
        });

        document.getElementById("scDevToolsJumpButton").addEventListener("click", function(){ 
            if(sendMessageAction != null){ sendMessageAction("avatar", "jump", "1");}
        });

        document.getElementById("scDevToolsRespawnButton").addEventListener("click", function(){ 
            if(sendMessageAction != null){ sendMessageAction("avatar", "respawn", "1");}
        });
    }

    init.call(self);
}