var Ankaa = Ankaa || {};
Ankaa.Client = Ankaa.Client || {};
Ankaa.Client.JSEngine = Ankaa.Client.JSEngine || {};

Ankaa.Client.JSEngine.BridgeResponsesManager = function()
{
    var self = this;
    
    var responsesAwaited = {};

    var init = function()
    {

    }

    this.createAwaitedResponseHandler = function(awaitedResponseId)
    {
        var myResponseId = awaitedResponseId
        responsesAwaited[myResponseId] = {"reponseId": myResponseId, "fullfilled": false, "rejected": false, "ended": false, "resolvFunc": null, "rejectFunc": null, "promise" : null, "response": null };
        responsesAwaited[myResponseId].promise = 
            (new Promise((resolve, reject) => { responsesAwaited[myResponseId].resolvFunc = resolve; responsesAwaited[myResponseId].rejectFunc = reject; }))
            .then(r=> { /*console.log(myResponseId+" enters then"); */ responsesAwaited[myResponseId].fullfilled = true; })
            .catch((e1)=> { /*console.log(myResponseId+ " enters catch"); */ console.log("Got an error in js_bridge:"); console.log(e1.message); console.log(e1.stack); responsesAwaited[myResponseId].rejected = true; })
            .finally(r=>{  /*console.log(myResponseId+" enters finally"); */ responsesAwaited[myResponseId].ended = true; });
        return responsesAwaited[myResponseId];
    }

    this.releaseReponseHandler = function(responseId, resp)
    {
        responsesAwaited[responseId].response = resp;
        responsesAwaited[responseId].resolvFunc();
    }

    this.getInfo = function(responseId)
    {
        return responseId + " [ fullfilled: "+ responsesAwaited[responseId].fullfilled + " ; rejected: " + responsesAwaited[responseId].rejected + " ; ended: " +responsesAwaited[responseId].ended+ " ]";
    }

    init.call(self);
}